<?php

/**
 * @file
 */

class gallery_assist_handler_field_counter extends views_handler_field {
  function construct() {
    parent::construct();
  }

  function element_type() {
    return 'div';
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['counter_prefix'] = array(
      '#title' => t('Counter Prefix'),
      '#type' => 'textfield',
      '#default_value' => $this->options['counter_prefix'],
      '#weight' => 4,
      '#size' => 16,
    );

    $ic_presets = imagecache_presets();
    $presets = array('none' => 'none');
    foreach ($ic_presets as $k => $v) {
      $presets[$k] = $v['presetname'];
    }

    $form['counter_suffix'] = array(
      '#title' => t('Counter Suffix'),
      '#type' => 'textfield',
      '#default_value' => $this->options['counter_suffix'],
      '#weight' => 4,
      '#size' => 16,
    );
  }

  function render($values) {

    $count = db_result(db_query("SELECT count(pid) FROM {gallery_assist_item} WHERE gref = %d", $values->{$this->field_alias}));
    $output = !empty($this->options['counter_prefix']) ? $this->options['counter_prefix'] : '';
    $output .= $count;
    $output .= !empty($this->options['counter_suffix']) ? $this->options['counter_suffix'] : '';

    return $output;
  }
}

