<?php

/**
 * @file
 */

class gallery_assist_handler_field_cover extends views_handler_field {
  function construct() {
    parent::construct();
    $this->additional_fields['opath'] = 'opath';
    $this->additional_fields['nid'] = 'nid';
    $this->additional_fields['pid'] = 'pid';
  }

  function element_type() {
    return 'div';
  }

  function option_definition() {
    $options = parent::option_definition();
    $options['linked_to'] = array('default' => 0);
    if (module_exists('imagecache')) {
      $options['icformat'] = array('default' => 'none');
    }
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['linked_to'] = array(
      '#title' => t('Linked to'),
      '#type' => 'select',
      '#options' => array(0 => 'node', 1 => 'image'),
      '#default_value' => $this->options['linked_to'],
      '#weight' => 4,
    );

    if (module_exists('imagecache')) {
      $ic_presets = imagecache_presets();
      $presets = array('none' => 'none');
      foreach ($ic_presets as $k => $v) {
        $presets[$k] = $v['presetname'];
      }

      $form['icformat'] = array(
        '#title' => t('Format'),
        '#type' => 'select',
        '#options' => $presets,
        '#default_value' => $this->options['icformat'],
        '#weight' => 4,
      );
    }
  }

  function render($values) {
    global $base_path;

    $type = db_result(db_query("SELECT type FROM {node} WHERE nid = %d", $values->{$this->aliases['nid']}));

    $iPath = preg_replace('/\/thm\//', '/img/', $values->{$this->field_alias});

    if (module_exists('imagecache') && $this->options['icformat'] != 'none') {
      $preset = imagecache_preset($this->options['icformat']);
    }
    else {
      $preset['presetname'] = $this->options['icformat'];
    }

    $data = array(
      'pid' => $values->{$this->aliases['pid']},
      'nid' => $values->{$this->aliases['nid']},
      'img' => $iPath,
      'tpath' => $values->{$this->field_alias},
      'opath' => $values->{$this->aliases['opath']},
      'presetname' => $preset['presetname'],
      'linked_to' => $this->options['linked_to'],
      'type' => $this->options['type'],
    );

    return theme('gallery_assist_display_cover', $data);
  }
}

